#ifndef ROOT_MyDPhiRho0
#define ROOT_MyDPhiRho0

//////////////////////////////////////////////////////////////////////////
//                                                                      //
// MyDPhiRho0                                                                //
//                                                                      //
// A CLEO DST Signal DPhiRho0
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "TObject.h"
#include "TClonesArray.h"
#include "TRefArray.h"
#include "TRef.h"
#include "TH1.h"
#include "TMath.h"
#include "TString.h"
#include "DTagVVProc/MyParticle.h"
#include "DTagVVProc/MyPhi.h"
#include "DTagVVProc/MyRho0.h"

class MyParticle;
class MyPhi;
class MyRho0;


class MyDPhiRho0 : public MyParticle {
 
 private:

  TRef* fPhi;   //Reference to Phi daughter
  TRef* fRho0;   //Reference to rho0 daughter
  float MBC;
  float DeltaE;


 public:
 
  MyDPhiRho0(const MyDPhiRho0& orig);
  MyDPhiRho0();
  virtual ~MyDPhiRho0();
  void Clear(Option_t *option="");

  void SetPhi(MyPhi* n) {*fPhi = n;} //Set phi daughter
  void SetRho0(MyRho0* n) {*fRho0 = n;} //Set rho0 daughte
  void SetMBC(float n) {MBC = n;}
  void SetDeltaE(float n) {DeltaE = n;}

  MyPhi* GetPhi() const {return (MyPhi*)(fPhi->GetObject());} //Get Phi daughter
  MyRho0* GetRho0() const {return (MyRho0*)(fRho0->GetObject());} //Get Rho0 daughter
  float GetMBC() {return MBC;}
  float GetDeltaE() {return DeltaE;}

  ClassDef(MyDPhiRho0,99)  //A Signal Candidate
};


#endif
