
#include "TRandom.h"
#include "TDirectory.h"
#include "TProcessID.h"
#include "Riostream.h"

#include "DTagVVProc/MyEvent.h"


ClassImp(MyEvent)

  //TClonesArray *MyEvent::fgMyTracks = 0;
  //TClonesArray *MyEvent::fgMyShowers = 0;
  //TClonesArray *MyEvent::fgMyDTags = 0;
  //TClonesArray *MyEvent::fgMyPions = 0;
  //TClonesArray *MyEvent::fgMyPi0s = 0;
  //TClonesArray *MyEvent::fgMyKaons = 0;
  //TClonesArray *MyEvent::fgMyPhotons = 0;
  //TClonesArray *MyEvent::fgMyMCParticles = 0;


//________________________________________________________________
MyEvent::MyEvent()
{
  // Create an MyEvent object.
  // When the constructor is invoked for the first time, 
  // the class static variables fgMyTracks/fgMyDTags/etc are 0 and the 
  // TClonesArrays fgMyTracks/fgMyDTags/etc are created.
  
  NTrk = 0;
  NShwr = 0;
  NDTag = 0;
  NPion = 0;
  NPi0 = 0;
  NPhoton = 0;
  NKaon = 0;
  NMCParticle = 0;

  fMyTracks = new TClonesArray("MyTrack", 1);
  //   if (!fgMyTracks) fgMyTracks = new TClonesArray("MyTrack", 0);
  //   fMyTracks = fgMyTracks;

  fMyShowers = new TClonesArray("MyShower", 1);
  //   if (!fgMyShowers) fgMyShowers = new TClonesArray("MyShower", 0);
  //   fMyShowers = fgMyShowers;
   
  fMyDTags = new TClonesArray("MyDTag", 0);
  //  if (!fgMyDTags) fgMyDTags = new TClonesArray("MyDTag", 0);
  //  fMyDTags = fgMyDTags;
   
  fMyPions = new TClonesArray("MyPion", 0);
  //  if (!fgMyPions) fgMyPions = new TClonesArray("MyPion", 0);
  //  fMyPions = fgMyPions;
   
  fMyPi0s = new TClonesArray("MyPi0", 0);
  //  if (!fgMyPi0s) fgMyPi0s = new TClonesArray("MyPi0", 0);
  //  fMyPi0s = fgMyPi0s;
  
  fMyPhotons = new TClonesArray("MyPhoton", 0);
  //  if (!fgMyPhotons) fgMyPhotons = new TClonesArray("MyPhoton", 0);
  //  fMyPhotons = fgMyPhotons;
  
  fMyKaons = new TClonesArray("MyKaon", 0);
  //  if (!fgMyKaons) fgMyKaons = new TClonesArray("MyKaon", 0);
  //  fMyKaons = fgMyKaons;
  
  fMyMCParticles = new TClonesArray("MyMCParticle", 1);
  //  if (!fgMyMCParticles) fgMyMCParticles = new TClonesArray("MyMCParticle", 0);
  //  fMyMCParticles = fgMyMCParticles;
}

//________________________________________________________________
MyEvent::~MyEvent()
{
  Clear();

  delete fMyTracks;
  delete fMyShowers;
  delete fMyDTags;
  delete fMyPions;
  delete fMyPi0s;
  delete fMyPhotons;
  delete fMyMCParticles;
  delete fMyKaons;

}


//________________________________________________________________
MyTrack *MyEvent::AddTrack()
{
  // Add a new track to the list of tracks for this event.
  // To avoid calling the very time consuming operator new 
  // for each track,
  // the standard but not well know C++ operator "new with placement"
  // is called. If tracks[i] is 0, a new MyTrack object will be created
  // otherwise the previous Track[i] will be overwritten.
  
  TClonesArray &tracks = *fMyTracks;
  MyTrack *track = new(tracks[NTrk++]) MyTrack();
  //Save reference to last MyTrack in the collection of MyTracks
  //  fLastMyTrack = track;
  return track;
}







//________________________________________________________________
MyShower *MyEvent::AddShower()
{
  // Add a new shower to the list of showers for this event.
  // To avoid calling the very time consuming operator new 
  // for each track,
  // the standard but not well know C++ operator "new with placement"
  // is called. If showers[i] is 0, a new MyShower object will 
  // be created
  // otherwise the previous MyShower[i] will be overwritten.
  
  TClonesArray &showers = *fMyShowers;
  MyShower *shower = new(showers[NShwr++]) MyShower();
  //Save reference to last MyShower in the collection of MyShowers
  //  fLastMyShower = shower;
  return shower;
}





//________________________________________________________________
MyDTag *MyEvent::AddDTag()
{
   // Add a new DTag object to the list of Dtags for this event.
   // To avoid calling the very time consuming operator new for each DTag,
   // the standard but not well know C++ operator "new with placement"
   // is called. If dtags[i] is 0, a new MyDTag object will be created
   // otherwise the previous DTag[i] will be overwritten.

   TClonesArray &dtags = *fMyDTags;
   MyDTag *dtag = new(dtags[NDTag++]) MyDTag();
   //Save reference to last MyDTag in the collection of MyDTags
   //   fLastMyDTag = dtag;
   return dtag;
}




//________________________________________________________________
MyPion *MyEvent::AddPion()
{
   // Add a new Pion object to the list of Pions for this event.
   // To avoid calling the very time consuming operator new for each Pion,
   // the standard but not well know C++ operator "new with placement"
   // is called. If pions[i] is 0, a new MyPion object will be created
   // otherwise the previous Pion[i] will be overwritten.

   TClonesArray &pions = *fMyPions;
   MyPion *pion = new(pions[NPion++]) MyPion();
   //Save reference to last MyPion in the collection of MyPions
   //   fLastMyPion = pion;
   return pion;
}


//________________________________________________________________
MyPi0 *MyEvent::AddPi0()
{
   // Add a new Pi0 object to the list of Pi0s for this event.
   // To avoid calling the very time consuming operator new for each Pi0,
   // the standard but not well know C++ operator "new with placement"
   // is called. If pi0s[i] is 0, a new MyPi0 object will be created
   // otherwise the previous Pi0[i] will be overwritten.

   TClonesArray &pi0s = *fMyPi0s;
   MyPi0 *pi0 = new(pi0s[NPi0++]) MyPi0();
   //Save reference to last MyPi0 in the collection of MyPi0s
   //   fLastMyPi0 = pi0;
   return pi0;
}





//________________________________________________________________
MyPhoton *MyEvent::AddPhoton()
{
   // Add a new Photon object to the list of Photons for this event.
   // To avoid calling the very time consuming operator new for each Photon,
   // the standard but not well know C++ operator "new with placement"
   // is called. If photons[i] is 0, a new MyPhoton object will be created
   // otherwise the previous Photon[i] will be overwritten.

   TClonesArray &photons = *fMyPhotons;
   MyPhoton *photon = new(photons[NPhoton++]) MyPhoton();
   //Save reference to last MyPhoton in the collection of MyPhotons
   //   fLastMyPhoton = photon;
   return photon;
}






//________________________________________________________________
MyKaon *MyEvent::AddKaon()
{
   // Add a new Kaon object to the list of Kaons for this event.
   // To avoid calling the very time consuming operator new for each Kaon,
   // the standard but not well know C++ operator "new with placement"
   // is called. If kaons[i] is 0, a new MyKaon object will be created
   // otherwise the previous Kaon[i] will be overwritten.

   TClonesArray &kaons = *fMyKaons;
   MyKaon *kaon = new(kaons[NKaon++]) MyKaon();
   //Save reference to last MyKaon in the collection of MyKaons
   //   fLastMyKaon = kaon;
   return kaon;
}







//________________________________________________________________
MyMCParticle *MyEvent::AddMCParticle()
{
   // Add a new MyMCParticle object to the list of MyMCParticles for this event.
   // To avoid calling the very time consuming operator new for each MyMCParticle,
   // the standard but not well know C++ operator "new with placement"
   // is called. If mcparticles[i] is 0, a new MyMCParticle object will be created
   // otherwise the previous mcparticle[i] will be overwritten.

   TClonesArray &mcparticles = *fMyMCParticles;
   MyMCParticle *mcparticle = new(mcparticles[NMCParticle++]) MyMCParticle();
   //Save reference to last MyMCParticle in the collection of MyMCParticles
   //   fLastMyMCParticle = mcparticle;
   return mcparticle;
}









//________________________________________________________________
void MyEvent::Clear(Option_t * /*option*/)
{


  fMyTracks->Clear("C"); //will also call MyTrack::Clear
  NTrk = 0;
  
  fMyShowers->Clear("C"); //will also call MyShower::Clear
  NShwr = 0;

  fMyDTags->Clear("C"); //will also call MyDTags::Clear
  NDTag = 0;

  fMyPions->Clear("C"); //will also call MyPions::Clear
  NPion = 0;

  fMyPi0s->Clear("C"); //will also call MyPi0s::Clear
  NPi0 = 0;

  fMyPhotons->Clear("C"); //will also call MyPhotons::Clear
  NPhoton = 0;

  fMyMCParticles->Clear("C"); //will also call MyMCParticle::Clear
  NMCParticle = 0;

  fMyKaons->Clear("C"); //will also call MyKaons::Clear
  NKaon = 0;

 }

//________________________________________________________________
//void MyEvent::Reset(Option_t * /*option*/)
//{
// Static function to reset all static objects for this event
//   fgMyTracks->Delete(option);

//   delete fgMyTracks; fgMyTracks = 0;
//   delete fgMyShowers; fgMyShowers = 0;
//   delete fgMyDTags; fgMyDTags = 0;
//   delete fgMyPions; fgMyPions = 0;
//   delete fgMyPi0s; fgMyPi0s = 0;
//   delete fgMyPhotons; fgMyPhotons = 0;
//   delete fgMyKaons; fgMyKaons = 0;
//   delete fgMyMCParticles; fgMyMCParticles = 0;
//}

