#ifndef ROOT_MyPhi
#define ROOT_MyPhi

//////////////////////////////////////////////////////////////////////////
//                                                                      //
// MyPhi                                                              //
//                                                                      //
// A CLEO DST Phi particle                                              //
//                                                                      //
//////////////////////////////////////////////////////////////////////////

#include "TObject.h"
#include "TClonesArray.h"
#include "TRefArray.h"
#include "TRef.h"
#include "TH1.h"
#include "TMath.h"
#include "TString.h"
#include "DTagVVProc/MyParticle.h"
#include "DTagVVProc/MyKaon.h"


//class TDirectory;

class MyParticle;

//----------------------------------------------------------
//
// Phi->KK candidates
//
//----------------------------------------------------------
class MyPhi : public MyParticle {
 
 private:

  TRef* fKPlus;   //Reference to K+ daughter
  TRef* fKMinus;   //Reference to K- daughter
 
 public:
  MyPhi(const MyPhi& orig);
  //  MyPhi(const TString name, const int code);
  MyPhi();
  virtual ~MyPhi();
  void  Clear(Option_t *option="");

  void SetKPlus(MyKaon* n) {*fKPlus = n;} //Set K+ daughter
  void SetKMinus(MyKaon* n) {*fKMinus = n;} //Set K- daughter

  MyKaon* GetKPlus() const {return (MyKaon*)(fKPlus->GetObject());} //Get K+ daughter
  MyKaon* GetKMinus() const {return (MyKaon*)(fKMinus->GetObject());} //Get K- daughter
     
  ClassDef(MyPhi,99)  //A Phi
};

#endif

